#ifndef _CSRMATRIX_H_
#define _CSRMATRIX_H_

// Hilfsprogramme 
#include <iostream>
#include "math.h"
using namespace std;
#include <cstdlib>

void gitter2(int n, int m,int* column_indices,double* entries,
	     int* row_offsets,double* a)
// generiert Laplace 2d zu nxm Gitter auf (0,1) als CSR-Format
// Gewichte: a(1) in x und a(2) in y Richtung, a(3) Massenmatrix
// matrix ist mit hx*hy Multipliziert.
{
  int i,j,l,pos,nnz,ke;
  double hx,hy;
  pos=0;
  nnz=0;
  ke=0;
  hx=1/double(n+1);
  hy=1/double(m+1);
  for (j=0;j<m;j++)
      {
      for (i=0;i<n;i++) 
        {
          l=0; 
      	  if (j>0) 
	    {
	      entries[ke]=-a[1]*hx/hy;
              column_indices[ke++]=pos-n;
              l++; 
            }
           if (i>0) 
	    {
	      entries[ke]=-a[0]*hy/hx;
              column_indices[ke++]=pos-1;
              l++ ;
            } 
          entries[ke]=2*a[0]*hy/hx+2*a[1]*hx/hy+hx*hy*a[2];
          column_indices[ke++]=pos;
          l++; 
           if (i<n-1) 
	    {
	      entries[ke]=-a[0]*hy/hx;
              column_indices[ke++]=pos+1;
              l++; 
            } 
           if (j<m-1) 
	    {
	      entries[ke]=-a[1]*hx/hy;
              column_indices[ke++]=pos+n;
              l++;
            } 
           row_offsets[pos]=nnz;
           nnz=nnz+l;
           pos++;
	}
      } 
  row_offsets[pos]=nnz; 
}



#endif
